.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\comdlg32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\comdlg32.lib

include masm32.inc
includelib masm32.lib


include	G:\RadASM\Masm\Inc\debug.inc
includelib	G:\RadASM\Masm\lib\debug.lib
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	  equ IDD_DLG1
IDC_EXIT      equ BTN_EXIT
IDC_TEXT      equ BTN_GET_TEXT
IDC_EDT1      equ IDC_EDT1
IDI_ICON      equ 200


;main.dlg
IDD_DLG1						equ 1000
IDC_GRP1						equ 1001
IDC_EDT1						equ 1002
BTN_GET_TEXT					equ 1003
BTN_EXIT						equ 1004

; Required data

.data
szTitle       TCHAR "TEST Edit Box window", 0
szError		  TCHAR "Please type some text",0
szErrortitle  TCHAR "Error",0
szCap         TCHAR "Our string",0
szString    db 'You wrote %s',0Dh,0Ah
            db 'Writing %s is nice',0Dh,0Ah
            db 'But it is nicer that we can see %s',0Dh,0Ah,0
szText_length			equ $ -szString
buffer2 db 100 dup(0) 
buffer   db 100 dup(0);this buffer is used to "hold" what we enter in the text box!
FinalszString	db 100 dup(0); buffer2 holds buffer + szString 
szReplace      BYTE    "%s", 0
.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hEdit1				dd ?
hRichEditDLL dd ?
COMMENT #
These should be in .data because they are initialized
buffer2 db 100 dup(0) 
buffer   db 100 dup(0);this buffer is used to "hold" what we enter in the text box!
FinalszString	db 100 dup(0); buffer2 holds buffer + szString #
.code

start:

INVOKE InitCommonControls

INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM



 .IF uMsg == WM_INITDIALOG

  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
  	; initialising our 2 editboxes
	INVOKE GetDlgItem,hWnd,IDC_EDT1	;Windows API result gets stored in eax
		mov hEdit1,eax				;assembler OPCODE stored flag flag from eax moved to hEdit1
	INVOKE SetFocus,hEdit1			;Windows API
  
    .ELSEIF uMsg == WM_COMMAND
        .if wParam == BTN_EXIT
            INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0
            
        .elseif wParam == BTN_GET_TEXT
            ;first we check if the user has inserted any text
			;if so we copy it to the second textbox
			invoke GetWindowTextLength,hEdit1		;Win API result gets stored in the eax register
			cmp eax,0							;Assembler OPCODE to compare 
			je @F								;Jump if equal to 0 to @@:
				
			;ok here we get only if user has typed some text
			invoke SendMessage,hEdit1,WM_GETTEXT,sizeof buffer,addr buffer  ;here is where we use our local variable ( we call the text we entered)
	;		invoke SendMessage,szString,WM_GETTEXT,sizeof szString,addr szString
			;invoke  wsprintf,addr buffer2,addr szString,addr buffer ; here we combine the text we entered from buffer with the text from szString 
	;		invoke SendMessage,FinalszString,WM_SETTEXT,addr buffer,addr szString
			;invoke  wsprintf,addr FinalszString,addr szString,addr buffer
			invoke  szRep, offset szString, offset FinalszString, offset szReplace, offset buffer
			
			;invoke lstrcpy,addr FinalszString,sizeof FinalszString
		
			invoke MessageBox,hWnd,addr FinalszString,addr szCap ,MB_ICONINFORMATION ;the stored string in buffer2 gets copied to editbox 2
			
			
				jmp Exit						;Assembler OPCDOE jmp means jump now to (Exit)
			@@:								;here is where we came from je @F (User didnt enter any text) also @F means jump forward @B would be jump back :)
			invoke MessageBox,hWnd,offset szError,offset szErrortitle ,MB_ICONINFORMATION
			Exit:			;We exit the Messageloop here
        .endif
      .ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
    
    .else
    COMMENT #
        this is needed for any unhandled dialog messages #
        mov     eax, FALSE
        ret
 .ENDIF

COMMENT ^
    The following is in the wrong place...
    
      .IF wParam == IDC_TEXT
  ;first we check if the user has inserted any text
			;if so we copy it to the second textbox
			invoke GetWindowTextLength,hEdit1		;Win API result gets stored in the eax register
			cmp eax,0							;Assembler OPCODE to compare 
			je @F								;Jump if equal to 0 to @@:
				
			;ok here we get only if user has typed some text
			invoke SendMessage,hEdit1,WM_GETTEXT,sizeof buffer,addr buffer  ;here is where we use our local variable ( we call the text we entered)
			invoke SendMessage,szString,WM_GETTEXT,sizeof szString,addr szString
			;invoke  wsprintf,addr buffer2,addr szString,addr buffer ; here we combine the text we entered from buffer with the text from szString 
			invoke SendMessage,FinalszString,WM_SETTEXT,addr buffer,addr szString
			invoke  wsprintf,addr FinalszString,addr szString,addr buffer
			invoke lstrcpy,addr FinalszString,sizeof FinalszString
		
			invoke MessageBox,hWnd,addr FinalszString,addr szCap ,MB_ICONINFORMATION ;the stored string in buffer2 gets copied to editbox 2
			
			
				jmp Exit						;Assembler OPCDOE jmp means jump now to (Exit)
			@@:								;here is where we came from je @F (User didnt enter any text) also @F means jump forward @B would be jump back :)
			invoke MessageBox,hWnd,offset szError,offset szErrortitle ,MB_ICONINFORMATION
			Exit:			;We exit the Messageloop here
			.ENDIF
		
  
  .IF wParam == IDC_EXIT 
      INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0

    .ENDIF
^
    xor eax,eax
  ret
DialogProc endp

end start